// utility to dynamically set debug level in NT coda kernel module
//
//  ntdebug <level names>
//
//  $Id: getdbgmsgs.c,v 1.2 2005/09/09 23:10:36 phil Exp $

/* BLURB gpl

                           Coda File System
                              Release 6

          Copyright (c) 2005 Carnegie Mellon University
                  Additional copyrights listed below

This  code  is  distributed "AS IS" without warranty of any kind under
the terms of the GNU General Public Licence Version 2, as shown in the
file  LICENSE.  The  technical and financial  contributors to Coda are
listed in the file CREDITS.

*/

/* Not as useful with the sysinternals.com dbgview utility! */

#include <windows.h>
#include <stdio.h>
#include <winioctl.h>
#include <string.h>
#include <ctype.h>
#include <wchar.h>
#include "coda.h"
#include "codafsctl.h"


void myperror(char *str)
{
    DWORD err = GetLastError();
    char buf[1000];
    
    FormatMessageA(FORMAT_MESSAGE_FROM_SYSTEM, NULL, err, 0, buf, sizeof(buf),
		   NULL);
    printf ("%s: %s\n", str, buf);
    exit (-1);
}

#define BUFSIZE 4096

int main (int argc, char *argv[])
{
    HANDLE h;
    LONG nBytesReturned;
    CHAR OutBuf[BUFSIZE];
    DWORD d;
    int n;
    int ctlcode = CODA_FSCTL_GETDBGMSG;

    int i;
    
    d = DefineDosDevice(DDD_RAW_TARGET_PATH, "codadev", "\\Device\\codadev");
    if ( d == 0 ) 
	myperror("DDD failed");
    h = CreateFile ("\\\\.\\codadev", GENERIC_READ | GENERIC_WRITE,
		    FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
		    OPEN_EXISTING, 0, NULL);
    if (h == INVALID_HANDLE_VALUE) {
	myperror ("CreateFile failed");
    }
    
    while (1) {
	if ((d = DeviceIoControl(h, ctlcode, NULL, 0,
				 OutBuf, BUFSIZE, &nBytesReturned, NULL))) {
	    if (nBytesReturned) 
		printf ("%s", OutBuf);
	    else
		fflush (stdout);
	} else {
	    myperror ("request failed\n");
	    return 1;
	}
    }
    
    return 0;
}

